# MulticallExtended

Enables calling multiple methods in a single call to the contract

### Functions <a href="#functions" id="functions"></a>

#### multicall <a href="#multicall" id="multicall"></a>

Call multiple functions in the current contract and return the data from all of them if they all succeed

*The `msg.value` should not be trusted for any method callable from multicall.*

```solidity
function multicall(uint256 deadline, bytes[] calldata data)
    external
    payable
    override
    checkDeadline(deadline)
    returns (bytes[] memory);
```

**Parameters**

| Name       | Type      | Description                                                              |
| ---------- | --------- | ------------------------------------------------------------------------ |
| `deadline` | `uint256` | The time by which this function must be called before failing            |
| `data`     | `bytes[]` | The encoded function data for each of the calls to make to this contract |

**Returns**

| Name     | Type      | Description                                                   |
| -------- | --------- | ------------------------------------------------------------- |
| `<none>` | `bytes[]` | results The results from each of the calls passed in via data |

#### multicall <a href="#multicall-1" id="multicall-1"></a>

Call multiple functions in the current contract and return the data from all of them if they all succeed

*The `msg.value` should not be trusted for any method callable from multicall.*

```solidity
function multicall(bytes32 previousBlockhash, bytes[] calldata data)
    external
    payable
    override
    checkPreviousBlockhash(previousBlockhash)
    returns (bytes[] memory);
```

**Parameters**

| Name                | Type      | Description                                                              |
| ------------------- | --------- | ------------------------------------------------------------------------ |
| `previousBlockhash` | `bytes32` |                                                                          |
| `data`              | `bytes[]` | The encoded function data for each of the calls to make to this contract |

**Returns**

| Name     | Type      | Description                                                   |
| -------- | --------- | ------------------------------------------------------------- |
| `<none>` | `bytes[]` | results The results from each of the calls passed in via data |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/smart-router/base/multicallextended.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
